
From: Suparna Bhattacharya <suparna@in.ibm.com>

The attached patch helped fix some short writes I was seeing with O_SYNC
and AIO.  Most likely this happened in the situation when pagevec_lookup()
didn't find all the pages being looked up in the page cache.  In that
situation accounting of how much of the range was written back wasn't being
taken care of correctly.




 mm/page-writeback.c |   19 ++++++++++---------
 1 files changed, 10 insertions(+), 9 deletions(-)






From: Suparna Bhattacharya <suparna@in.ibm.com>

The attached patch helped fix some short writes I was seeing with O_SYNC
and AIO.  Most likely this happened in the situation when pagevec_lookup()
didn't find all the pages being looked up in the page cache.  In that
situation accounting of how much of the range was written back wasn't being
taken care of correctly.




 mm/page-writeback.c |   19 ++++++++++---------
 1 files changed, 10 insertions(+), 9 deletions(-)




diff -upN reference/mm/page-writeback.c current/mm/page-writeback.c
--- reference/mm/page-writeback.c	2004-04-29 10:39:24.000000000 -0700
+++ current/mm/page-writeback.c	2004-04-29 10:39:24.000000000 -0700
@@ -597,19 +597,19 @@ static ssize_t operate_on_page_range(str
 	pgoff_t next = first, curr = first;
 	struct pagevec pvec;
 	ssize_t ret = 0, bytes = 0;
-	int i;
+	int i, nr;
 
 	if (count == 0)
 		return 0;
 
 	pagevec_init(&pvec, 0);
-	while (pagevec_lookup(&pvec, mapping, &next,
-				min((pgoff_t)PAGEVEC_SIZE, last - next + 1))) {
+	while ((nr = pagevec_lookup(&pvec, mapping, &next,
+				min((pgoff_t)PAGEVEC_SIZE, last - next + 1)))) {
 		for (i = 0; i < pagevec_count(&pvec); i++) {
 			struct page *page = pvec.pages[i];
 
 			curr = page->index;
-			if ((curr > next) || !page->mapping) /* truncated ?*/ {
+			if (page->mapping != mapping) /* truncated ?*/ {
 				curr = next;
 				break;
 			} else {
@@ -619,16 +619,17 @@ static ssize_t operate_on_page_range(str
 				if (PageError(page)) {
 					if (!ret)
 						ret = -EIO;
-				}
+				} else
+					curr++;
 			}
-			curr++;
-			if (next > last)
-				break;
 		}
 		pagevec_release(&pvec);
-		if ((next > last) || (ret == -EIOCBRETRY))
+		if ((ret == -EIOCBRETRY) || (next > last))
 			break;
 	}
+	if (!nr)
+		curr = last + 1;
+
 	bytes = (curr << PAGE_CACHE_SHIFT) - pos;
 	if (bytes > count)
 		bytes = count;
